import asyncio
from typing import AsyncIterable

from v6d2ctx.context import Context

from v6d3music.core.create_ytaudio import create_ytaudio
from v6d3music.core.ytaudio import YTAudio
from v6d3music.utils.info_tuple import info_tuple


async def create_ytaudios(ctx: Context, infos: list[info_tuple]) -> AsyncIterable[YTAudio]:
    for audio in await asyncio.gather(
            *[
                create_ytaudio(ctx, info, effects, already_read, tor)
                for
                info, effects, already_read, tor
                in
                infos
            ]
    ):
        yield audio
