from typing import AsyncIterable

from v6d2ctx.context import Context

from v6d3music.core.create_ytaudios import create_ytaudios
from v6d3music.core.ytaudio import YTAudio
from v6d3music.utils.entries_effects_for_args import entries_effects_for_args
from v6d3music.utils.info_tuple import info_tuple


async def yt_audios(ctx: Context, args: list[str]) -> AsyncIterable[YTAudio]:
    tuples: list[info_tuple] = []
    async for info, effects, already_read, tor in entries_effects_for_args(args, ctx.guild.id):
        tuples.append((info, effects, already_read, tor))
        if len(tuples) >= 5:
            async for audio in create_ytaudios(ctx, tuples):
                yield audio
            tuples.clear()
    async for audio in create_ytaudios(ctx, tuples):
        yield audio
