import re

import discord


def speed_quotient(options: str) -> float:
    options = options or ''
    options = ''.join(c for c in options if not c.isspace())
    options += ','
    quotient: float = 1.0
    asetrate: str
    # noinspection RegExpSimplifiable
    for asetrate in re.findall(r'asetrate=([0-9.]+?),', options):
        try:
            quotient *= float(asetrate) / discord.opus.Encoder.SAMPLING_RATE
        except ValueError:
            pass
    atempo: str
    # noinspection RegExpSimplifiable
    for atempo in re.findall(r'atempo=([0-9.]+?),', options):
        try:
            quotient *= float(atempo)
        except ValueError:
            pass
    quotient = max(0.1, min(10.0, quotient))
    return quotient
